proyecto/cms/urls.py
from django.urls import path

from . import views

urlpatterns = [
    path('', views.index),
    path('loggedIn', views.loggedIn),
    path('logout', views.logout_view),
    path('<str:llave>', views.get_content),

]

proyecto/proyecto/urls.py
from django.contrib import admin
from django.urls import include, path
from django.contrib.auth.views import LoginView as login

urlpatterns = [
    path('cms/', include('cms.urls')),
    path('admin/', admin.site.urls),
    path('login', login.as_view()) # esta vista realiza todas las acciones necesarias para
    # gestionar el login del usuario haciendo uso de una plantilla.
]

proyecto/cms/models.py
from django.db import models

class Contenido(models.Model):
    clave = models.CharField(max_length=64)
    valor = models.TextField()

    def __str__(self):
        return self.clave
        
    def tiene_as(self):
        return ('a' in self.valor)

class Comentario(models.Model):
    contenido = models.ForeignKey(Contenido, on_delete=models.CASCADE)
    titulo = models.CharField(max_length=200)
    cuerpo = models.TextField(blank=False)
    fecha = models.DateTimeField('publicado')
    
    def __str__(self):
        return self.titulo
        
    def tiene_as(self):
        return ('a' in self.titulo)

proyecto/cms/views.py
from django.http import HttpResponse
from django.shortcuts import get_object_or_404, render
from django.views.decorators.csrf import csrf_exempt
from django.utils import timezone
from django.template import loader
from django.contrib.auth import logout
from django.shortcuts import redirect

from .models import Contenido, Comentario

@csrf_exempt
def get_content(request, llave):
    if request.method == "PUT":
        valor = request.body.decode('utf-8')
    elif request.method == "POST": # si tenemos un POST tenemos que comprobar la acción para ver que tipo de formulario a devolver
        action = request.POST['action']
        if action == "Enviar Contenido": # dentro de POST tenemos que detectar si estamos añadiendo un comentario o contenido
            valor = request.POST['valor']
    if request.method == "PUT" or (request.method == "POST" and action == "Enviar Contenido"):
        try:
            c = Contenido.objects.get(clave=llave)
            c.valor = valor
        except Contenido.DoesNotExist:
            c = Contenido(clave=llave, valor=valor)
            c.save()
    if request.method == "POST" and action == "Enviar Comentario":
            c = Contenido.objects.get(clave=llave)
            titulo = request.POST['titulo']
            cuerpo = request.POST['cuerpo']
            fecha = timezone.now()
            q = Comentario(contenido=c, titulo=titulo, cuerpo=cuerpo, fecha=fecha)
            q.save()
    try:
        contenido = Contenido.objects.get(clave=llave)
        context = {'contenido': contenido}
    except Contenido.DoesNotExist:
        context = {}
        return render(request, 'cms/not_content.html', context)
        # en el formulario not_content examino si el usuario está autenticado o no, si no lo está, no puede añadir contenido.

    return render(request, 'cms/content.html', context)

def loggedIn(request): # comprueba que haya una sesión abierta, en tal caso cuando pidamos loggedIn nos devolverá un usuario
    if request.user.is_authenticated: # comprobamos si el usuario está autenticado
        logged = "Logged in as " + request.user.username
    else: # en casod e que no, proporcionamos un link para poder logguearnos.
        logged = "Not logged in. <a href='/admin/'> Login here </a>"
    return HttpResponse(logged)

def logout_view(request):
    logout(request)  # con logout salimos de la sesión
    return redirect("/cms/")  # retornamos a la pagina principal de nuestra aplicación

def index(request):
    content_list = Contenido.objects.all()[:5]
    context = {'content_list': content_list}
    return render(request, 'cms/index.html', context)

proyecto/cms/templates/cms/content.html
<h3>{{ contenido.valor }}</h3>
{% for comentario in contenido.comentario_set.all %}
    <hr>
    <h3>{{ comentario.titulo }}</h3><br>
        {{ comentario.cuerpo }}<br>
        Enviado el {{ comentario.fecha }}<br>
{% endfor %}

<hr>
<br>
<form action="" method="POST">
  Nuevo contenido para esta pagina:
  <input type="text" name="valor">
  <input type="submit" name="action" value="Enviar Contenido">
</form>

<br>
<form action="" method="POST">
  Introduce un nuevo comentario para esta página: 
  <br>Título: <input type="text" name="titulo">
  <br>Cuerpo: <input type="text" name="cuerpo">
  <input type="submit" name="action" value="Enviar Comentario">
</form>

proyecto/cms/templates/cms/index.html
{% if content_list %}
    <ul>
    {% for content in content_list %}
        <li><a href="/cms/{{ content.clave }}">{{ content.clave }}</a></li>
    {% endfor %}
    </ul>
{% else %}
    <p>No contents are available.</p>
{% endif %}

proyecto/cms/templates/cms/not_content.html
{% if request.user.is_authenticated %}
    <p>Bienvenido {{ request.user.username }} </p>
    <p>Este contenido no existe pero puedes añadirlo </p>

    <form action="" method="POST">
        Nuevo valor para la pagina:
        <input type="text" name="valor">
        <input type="submit" name="action" value="Enviar Contenido">
    </form>
{% else %}
    <p> Para añadir contenido tienes que estar logueado, puedes hacerlo aquí. <a href="/login" > Login here </a> </p>
{% endif %}